structure Str: STR =
  struct
    datatype Str = Str of string | Conc of Str * Str

    fun Str2string x =
	let fun Str2list (Str s) acc = (List.rev (String.explode s))@acc
	      | Str2list (Conc(s1, s2)) acc = Str2list s2 (Str2list s1 acc)
	in
	    String.implode(List.rev(Str2list x []))
	end

(*      fun Str2string (Conc(s1,s2)) = (Str2string s1)^(Str2string s2) *)
(*        | Str2string (Str s) = s *)

    fun strlist2str sep [] = ""
      | strlist2str sep [hd] = hd
      | strlist2str sep (hd::tl) = hd^sep^(strlist2str sep tl)

    fun Strlist2Str sep [] = (Str "")
      | Strlist2Str sep [hd] = hd
      | Strlist2Str sep (hd::tl) = Conc(Conc(hd, Str sep), Strlist2Str sep tl)

    fun bool2str true = "true"
      | bool2str false = "false"

    (* Some convenient functions for optional arguments *)
    fun option2string str NONE = str
      | option2string _ (SOME s) = s

    fun option2Str str NONE = str
      | option2Str _ (SOME s) = s

    (* Run the function on the value or return the `default' one if
       the value is NONE.
       Useful for converting optional values to strings. *)
    fun optionPrint ff def NONE = def
      | optionPrint ff _ (SOME v) = ff v

  end
